// Compiler options: -t:library
using System;
using System.Runtime.CompilerServices;

[assembly: InternalsVisibleTo ("gtest-friend-05")]
[assembly: InternalsVisibleTo ("gtest-friend-06")]
[assembly: InternalsVisibleTo ("gtest-friend-07")]
[assembly: InternalsVisibleTo ("gtest-friend-08")]

public class FriendClass
{
	// Static members
	
	internal static  mutable  StaticFriendField : int;
	
	internal static StaticFriendProperty : int {
		get {
			 1;
		}
	}

	internal static StaticFriendMethod () :  int
	{
		 2;
	}

	// Instance members
	
	internal  mutable  InstanceFriendField : int;
	
	internal InstanceFriendProperty : int {
		get {
			 1;
		}
	}

	internal InstanceFriendMethod () :  int 
	{
		 2;
	}

	// Nested classes
	internal class NestedInternalClass
	{
	}

	protected internal class NestedProtectedInternalClass
	{
	}
}

//
// This is an internal class
//
class InternalFriendClass
{
}


